//This file have nessessory facedetect modules
#include"avenger.h"
IplImage* detect_and_draw( IplImage* img )	{
	const char* cascade_name ="./haarcascade_frontalface_alt.xml";	// Create a string that contains the exact cascade name
	static CvMemStorage* storage = 0;	// Create memory for calculations
	static CvHaarClassifierCascade* cascade = 0;	// Create a new Haar classifier
	int scale = 1;
	IplImage* temp = cvCreateImage( cvSize(img->width/scale,img->height/scale), 8, 3 );	// Create a new image based on the input image
	CvPoint pt1, pt2;	// Create two points to represent the face locations
	int i;
	cascade = (CvHaarClassifierCascade*)cvLoad( cascade_name, 0, 0, 0 );	// Load the HaarClassifierCascade
	if( !cascade )	{	// Check whether the cascade has loaded successfully. Else report and error and quit
		fprintf( stderr, "Error [3]: Could not load classifier cascade | check the cascade file\n" );
		return NULL;
	}
	storage = cvCreateMemStorage(0);	// Allocate the memory storage
	cvClearMemStorage( storage );	// Clear the memory storage which was used before
	if( cascade )	{	// Find whether the cascade is loaded, to find the faces. If yes, then:
		CvSeq* faces = cvHaarDetectObjects( img, cascade, storage,// There can be more than one face in an image. So create a growable sequence of faces.
                                            1.1, 2, CV_HAAR_DO_CANNY_PRUNING,	// Detect the objects and store them in the sequence
                                            cvSize(40, 40) );
		for( i = 0; i < (faces ? faces->total : 0); i++ )	{	// Loop the number of faces found.
			CvRect* r = (CvRect*)cvGetSeqElem( faces, i );	// Create a new rectangle for drawing the face
			pt1.x = r->x*scale;	// Find the dimensions of the face,and scale it if necessary
			pt2.x = (r->x+r->width)*scale;
			pt1.y = r->y*scale;
			pt2.y = (r->y+r->height)*scale;
			cvRectangle( img, pt1, pt2, CV_RGB(218,0,0), 2, 8, 0 );	//Draw the rectangle in the input image
        	}
	}
	cvReleaseImage( &temp );	// Release the temp image created.
	return img;
}

