//This is the main file which drives the main loop
#include"avenger.h"
int main(int argc, char *argv[])        {
        IplImage* frame = 0;      //An image for frames from video
        CvCapture* capture = 0; //A video capture structure
        cvNamedWindow("Avenger", CV_WINDOW_AUTOSIZE);
        if(argc<2)      {       //If no video input is given by the user...
                printf("\nError [0] Usage: avenger <video_source>\n");    //Then, let him know that...
                exit(0);
        }
	if(!strncmp(argv[1],"-f",2))	//If the first argument is 1, it should be a video file
		capture=cvCaptureFromAVI(argv[2]);      //Reading from avi file -> capture
	if(!strncmp(argv[1],"-c",2))	//If the first argument is 2, it should be a camera
		capture=cvCaptureFromCAM( CV_CAP_ANY );      //Reading from camera -> capture
        if(capture==NULL)       {  //If the capture can't get the correct video input
                printf("\nError [1]: Initializing video input failed, check your usage\n");
                exit(0);
        }
        do      {
                frame = cvQueryFrame(capture);   //A single frame
                if( frame == NULL )   {
                        printf("\nError [2]: Can't initialize the image using a frame\n");
                        continue;
                }
		cvShowImage("Avenger" , detect_and_draw( frame ));
	}while(cvWaitKey(2)==-1);	//waits for a keypress for 1000/fps (if a key pressed, it will exit) if not delays correctly for the next frame
        cvReleaseCapture(&capture);     //Releasing cature
        cvDestroyWindow("Avenger");     //Close the window
        return 0;
}
